<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
    <xs:element name="projectConfig">
        <xs:complexType>
            <xs:sequence>
                <xs:element name="settings" minOccurs="1">
                    <xs:annotation>
                        <xs:documentation>Parameters used by the panel to configure the components.</xs:documentation>
                    </xs:annotation>
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element minOccurs="0" name="fileSwitchTimeOut">
                                <xs:annotation>
                                    <xs:documentation>Maximum delay to wait for a file switch. 0 means wait infinitely.</xs:documentation>
                                </xs:annotation>
                                <xs:simpleType>
                                    <xs:restriction base="xs:integer">
                                        <xs:minInclusive value="0"/>
                                    </xs:restriction>
                                </xs:simpleType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element name="alarm">
                    <xs:annotation>
                        <xs:documentation>Alarm archive configuration.</xs:documentation>
                    </xs:annotation>
                    <xs:complexType>
                        <xs:attribute name="deletionCycleFrequency" type="xs:integer" use="required"
                        />
                    </xs:complexType>
                </xs:element>
                <xs:element minOccurs="0" name="frontEndList">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element name="frontEnd" maxOccurs="unbounded" minOccurs="1">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element name="type">
                                            <xs:complexType>
                                                <xs:choice>
                                                  <xs:element name="MODBUS">
                                                  <xs:complexType>
                                                  <xs:attribute name="dataServerPort"
                                                  type="xs:integer" use="required"/>
                                                  <xs:attribute name="frontEndIPAdress"
                                                  type="xs:string" use="required"/>
                                                  <xs:attribute name="driverNum" use="required">
                                                  <xs:simpleType>
                                                  <xs:restriction base="xs:integer">
                                                  <xs:minInclusive value="2"/>
                                                  </xs:restriction>
                                                  </xs:simpleType>
                                                  </xs:attribute>
                                                  </xs:complexType>
                                                  </xs:element>
                                                  <xs:element name="S7">
                                                  <xs:complexType>
                                                  <xs:attribute name="driverNum" use="required">
                                                  <xs:simpleType>
                                                  <xs:restriction base="xs:integer">
                                                  <xs:minInclusive value="2"/>
                                                  </xs:restriction>
                                                  </xs:simpleType>
                                                  </xs:attribute>
                                                  </xs:complexType>
                                                  </xs:element>
                                                </xs:choice>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                    <xs:attribute name="appName" type="xs:string"/>
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element minOccurs="0" name="archivesList">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element name="archives" maxOccurs="unbounded" minOccurs="1">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element name="ANA" type="archive">
                                            <xs:annotation>
                                                <xs:documentation>Analog archive configuration.</xs:documentation>
                                            </xs:annotation>
                                        </xs:element>
                                        <xs:element name="BOOL" type="archive">
                                            <xs:annotation>
                                                <xs:documentation>Bool archive configuration.</xs:documentation>
                                            </xs:annotation>
                                        </xs:element>
                                        <xs:element name="EVENT" type="archive">
                                            <xs:annotation>
                                                <xs:documentation>Event archive configuration.</xs:documentation>
                                            </xs:annotation>
                                        </xs:element>
                                    </xs:sequence>
                                    <xs:attribute name="appName" type="xs:string" use="required"/>
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element minOccurs="0" name="userAccessControl">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element minOccurs="0" name="LDAP">
                                <xs:complexType>
                                    <xs:attribute name="use" type="xs:boolean"/>
                                </xs:complexType>
                            </xs:element>
                            <xs:element minOccurs="0" name="centralServer">
                                <xs:complexType>
                                    <xs:attribute name="serverName" type="xs:string" use="optional"
                                    />
                                </xs:complexType>
                            </xs:element>
                            <xs:element minOccurs="0" name="domainList">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element maxOccurs="unbounded" minOccurs="1"
                                            name="domain">
                                            <xs:complexType>
                                                <xs:sequence>
                                                  <xs:element maxOccurs="unbounded" minOccurs="1"
                                                  name="privilege">
                                                  <xs:complexType>
                                                  <xs:attribute name="name" use="required"/>
                                                  </xs:complexType>
                                                  </xs:element>
                                                </xs:sequence>
                                                <xs:attribute name="name" use="required"/>
                                                <xs:attribute name="fullName" use="required"/>
                                                <xs:attribute name="comment" use="required"/>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                            <xs:element minOccurs="0" name="groupList">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element maxOccurs="unbounded" minOccurs="1" name="group">
                                            <xs:complexType>
                                                <xs:sequence>
                                                  <xs:element maxOccurs="unbounded" minOccurs="1"
                                                  name="privilege">
                                                  <xs:complexType>
                                                  <xs:attribute name="domain" use="required"/>
                                                  <xs:attribute name="privilege" use="required"/>
                                                  </xs:complexType>
                                                  </xs:element>
                                                </xs:sequence>
                                                <xs:attribute name="name" use="required"/>
                                                <xs:attribute name="fullName" use="required"/>
                                                <xs:attribute name="description" use="required"/>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                            <xs:element minOccurs="0" name="eGroupsMapping">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element maxOccurs="unbounded" name="mapping">
                                            <xs:complexType>
                                                <xs:attribute name="groupName" use="required"/>
                                                <xs:attribute name="egroupName" use="required"/>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element minOccurs="0" name="emailConfigurations">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element maxOccurs="unbounded" name="emailConfiguration">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element maxOccurs="unbounded" name="receiver">
                                            <xs:complexType>
                                                <xs:attribute name="address" use="required">
                                                  <xs:simpleType>
                                                  <xs:restriction base="xs:string">
                                                  <xs:minLength value="1"/>
                                                  </xs:restriction>
                                                  </xs:simpleType>
                                                </xs:attribute>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                    <xs:attribute name="systemName">
                                        <xs:simpleType>
                                            <xs:restriction base="xs:string">
                                                <xs:minLength value="1"/>
                                            </xs:restriction>
                                        </xs:simpleType>
                                    </xs:attribute>
                                    <xs:attribute name="configName" use="required">
                                        <xs:simpleType>
                                            <xs:restriction base="xs:string">
                                                <xs:minLength value="1"/>
                                            </xs:restriction>
                                        </xs:simpleType>
                                    </xs:attribute>
                                    <xs:attribute name="maxPerDay" type="xs:int" use="optional"/>
                                    <xs:attribute name="htmlLink" type="xs:string" use="optional"/>
                                    <xs:attribute name="senderAddress" use="required">
                                        <xs:simpleType>
                                            <xs:restriction base="xs:string">
                                                <xs:minLength value="1"/>
                                            </xs:restriction>
                                        </xs:simpleType>
                                    </xs:attribute>
                                    <xs:attribute name="domain" type="xs:string" use="optional"/>
                                    <xs:attribute name="SMTPserver" type="xs:string" use="optional"
                                    />
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
                <xs:element minOccurs="0" name="autoLogout">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element name="warningTimeout">
                                <xs:complexType>
                                    <xs:attribute name="hours" use="required"/>
                                    <xs:attribute name="minutes" use="required"/>
                                </xs:complexType>
                            </xs:element>
                            <xs:element name="commitTimeout">
                                <xs:complexType>
                                    <xs:attribute name="hours" use="required"/>
                                    <xs:attribute name="minutes" use="required"/>
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                    </xs:complexType>
                </xs:element>
            </xs:sequence>
            <xs:attribute name="appName" type="xs:string" use="required"/>
            <xs:attribute name="distributedPortNumber">
                <xs:simpleType>
                    <xs:restriction base="xs:integer">
                        <xs:maxInclusive value="65535"/>
                        <xs:minInclusive value="1"/>
                    </xs:restriction>
                </xs:simpleType>
            </xs:attribute>
            <xs:attribute name="backupPath" use="required">
                <xs:annotation>
                    <xs:documentation>Path MUST end with a "/" on Linux or a "\" on Windows.</xs:documentation>
                </xs:annotation>
                <xs:simpleType>
                    <xs:restriction base="xs:string">
                        <xs:pattern value=".*/"/>
                        <xs:pattern value=".*\\"/>
                    </xs:restriction>
                </xs:simpleType>
            </xs:attribute>
            <xs:attribute name="defaultPanel" type="xs:string"/>
        </xs:complexType>
        <xs:unique name="archiveManagerNumber">
            <xs:selector xpath="archives/*"/>
            <xs:field xpath="@managerNum"/>
        </xs:unique>
        <xs:unique name="applicationDriver">
            <xs:selector xpath="frontEnd/type/*"/>
            <xs:field xpath="@driverNum"/>
        </xs:unique>
        <xs:unique name="archiveName">
            <xs:selector xpath="archives"/>
            <xs:field xpath="@appName"/>
        </xs:unique>
    </xs:element>
    <xs:complexType name="archive">
        <xs:attribute name="managerNum" use="required">
            <xs:simpleType>
                <xs:restriction base="xs:integer">
                    <xs:minInclusive value="6"/>
                </xs:restriction>
            </xs:simpleType>
        </xs:attribute>
        <xs:attribute name="numberOfValues" type="xs:integer" use="required"/>
        <xs:attribute name="numberOfDPEs" type="xs:integer" use="required"/>
        <xs:attribute name="numberOfFiles" type="xs:integer" use="required"/>
    </xs:complexType>
</xs:schema>
